#include "includes.h"

void list(char * drive)
{
    int i;
    struct struc_bootmanager btmgr;
    
    bmread(drive, &btmgr);
    if (btmgr.sbmkdata.kernel_flags & KNLFLAG_SECURITY)
	printf("The kernel is in security lock mode\n");
    if ((btmgr.sbmkdata.kernel_flags & KNLFLAG_FIRSTRUN) && 
	(!(btmgr.sbmkdata.kernel_flags & KNLFLAG_NOAUTOSCAN)))
	printf("The SBM will reread all hard drives next startup\n");
    if (btmgr.sbmkdata.root_password)
	printf("The boot manager is guarded by a ROOT PASSWORD\n");
    if (btmgr.sbmkdata.direct_boot_record!=255)
	printf("After next startup the %d. record will be started instead of default\n", btmgr.sbmkdata.direct_boot_record+1);
    printf("The delay time: %d\n", btmgr.sbmkdata.delay_time);
    printf("The menuitems: \n");
    printf("%-3s %3s %6s %16s %20s %s\n","ID","DRV","PART","NAME","TYPE", "PROPERITIES");
    for (i=0 ; i<MAX_RECORD_NUM ; i++)
    {
        if (reccheck(btmgr.sbmkdata.boot_records[i]))
	{
    	    printf("%d.  %3s %6s %16s %20s", i+1,
              drvidtostring(btmgr.sbmkdata.boot_records[i].drive_id), 
              partidtostring(btmgr.sbmkdata.boot_records[i].part_id), 
	      btmgr.sbmkdata.boot_records[i].name,
              typetostring(btmgr.sbmkdata.boot_records[i].type));
	    if (i==btmgr.sbmkdata.default_record)
		printf(" DEF");
	    if (btmgr.sbmkdata.boot_records[i].flags & INFOFLAG_AUTOACTIVE)
		printf(" AUACT");
	    if (btmgr.sbmkdata.boot_records[i].flags & INFOFLAG_AUTOHIDE)
		printf(" AUHID");
	    if (btmgr.sbmkdata.boot_records[i].password)
		printf(" PASS");
	    if (btmgr.sbmkdata.boot_records[i].ext_flags & EXTFLAG_HAVEKEYS)
		printf(" KEYS");
	    if (btmgr.sbmkdata.boot_records[i].ext_flags & EXTFLAG_SCHEDULED)
	    {
		printf(" SCHE\n \\--This record is the default between %.2d:%.2d and %.2d:%.2d",
		       btmgr.sbmkdata.boot_records[i].begin_time/60,
		       btmgr.sbmkdata.boot_records[i].begin_time%60,
		       btmgr.sbmkdata.boot_records[i].end_time/60,
		       btmgr.sbmkdata.boot_records[i].end_time%60);
	    }
	    printf("\n");
	}
    }
    free(btmgr.data);
}
