#include "includes.h"

int parseschedule(char *scheset, int *bh, int *bm, int *eh, int *em)
{
    printf("%s(%d)\n", scheset, strlen(scheset));
    if ((strlen(scheset)==11)&&
	(isdigit(scheset[0])) && (isdigit(scheset[1])) && (scheset[2]==':') &&
	(isdigit(scheset[3])) && (isdigit(scheset[4])) && (scheset[5]=='-') &&
	(isdigit(scheset[6])) && (isdigit(scheset[7])) && (scheset[8]==':') &&
	(isdigit(scheset[9])) && (isdigit(scheset[10])) && (scheset[11]==0))
    {
    	*bh=(scheset[0]-48)*10+(scheset[1]-48);
	*bm=(scheset[3]-48)*10+(scheset[4]-48);
	*eh=(scheset[6]-48)*10+(scheset[7]-48);
	*em=(scheset[9]-48)*10+(scheset[10]-48);
    }
    else
    {
	return 0;
    }
    
    if ((*bh>24)||(*bh<0)||(*eh>24)||(*eh<0)||
	(*bm>60)||(*bm<0)||(*em>60)||(*em<0))
	return 0;
	
    if (*eh*60+*em<*bh*60+*bm)
	return 0;
    return 1;
}

void schedule(char *drive, int recnum, char *scheset)
{
    struct struc_bootmanager btmgr;
    
    bmread(drive, &btmgr);
    if (reccheck(btmgr.sbmkdata.boot_records[recnum]))
    {
	int eh,bh,bm,em;
	if (!scheset)
	{
	    btmgr.sbmkdata.boot_records[recnum].ext_flags&=(byte)~EXTFLAG_SCHEDULED;
	    btmgr.sbmkdata.boot_records[recnum].begin_time=0;
	    btmgr.sbmkdata.boot_records[recnum].end_time=0;
	}
	else if (parseschedule(scheset, &bh, &bm, &eh, &em))
	{
	    btmgr.sbmkdata.boot_records[recnum].ext_flags|=EXTFLAG_SCHEDULED;
	    btmgr.sbmkdata.boot_records[recnum].begin_time=bh*60+bm;
	    btmgr.sbmkdata.boot_records[recnum].end_time=eh*60+em;
	}
	else
	{
	    fprintf(stderr,"Wrong schedule time!\n");
	    usage();
	}
    }
    else
    {
        fprintf(stderr,"The given record isn't good (schedule)!\n");
	exit(-3);
    }
    bmwrite(drive, &btmgr);
    free(btmgr.data);
}
